================
folder-structure
================

This is the documentation of **folder-structure**. Hierarchical file systems are the most ubiquitous
data storage medium for research and other technical data. While not required, the folder structure
and order in these file systems are imbued with meaning that is *ad hoc/bespoke* and arguably fragile.

Therefore to improve compliance with the folder structure required by a project, **folder-structure**
generates folders, and all necessary descendants (subfolders) for new iterations, samples, or steps.

This reads in object definitions from a JSON-based file (schema). These objects define the contents of
each folder in a nested fashion to create complex folder hierarchies simply and repeatably. For example::

    [
        {
            "type": "Foo",
            "base": "Folder",
            "contains": {
                "bar": "Bar",
                "baz": "Baz"
            }
        },
        {
            "type": "Bar",
            "base": "Folder"
        },
        {
            "type": "Baz",
            "base": "Folder"
        }
    ]

can be used to create a top-level *Foo* folder with two subfolders: *Bar* and *Baz*. The same schema
could also be used to add a second (or third, fourth, etc.) "Bar" folder.

Contents
========

.. toctree::
   :maxdepth: 2

   Overview <readme>
   Contributions & Help <contributing>
   License <license>
   Authors <authors>
   Changelog <changelog>
   Module Reference <api/modules>


Indices and tables
==================

* :ref:`genindex`
* :ref:`modindex`
* :ref:`search`

.. _toctree: https://www.sphinx-doc.org/en/master/usage/restructuredtext/directives.html
.. _reStructuredText: https://www.sphinx-doc.org/en/master/usage/restructuredtext/basics.html
.. _references: https://www.sphinx-doc.org/en/stable/markup/inline.html
.. _Python domain syntax: https://www.sphinx-doc.org/en/master/usage/restructuredtext/domains.html#the-python-domain
.. _Sphinx: https://www.sphinx-doc.org/
.. _Python: https://docs.python.org/
.. _Numpy: https://numpy.org/doc/stable
.. _SciPy: https://docs.scipy.org/doc/scipy/reference/
.. _matplotlib: https://matplotlib.org/contents.html#
.. _Pandas: https://pandas.pydata.org/pandas-docs/stable
.. _Scikit-Learn: https://scikit-learn.org/stable
.. _autodoc: https://www.sphinx-doc.org/en/master/ext/autodoc.html
.. _Google style: https://google.github.io/styleguide/pyguide.html#38-comments-and-docstrings
.. _NumPy style: https://numpydoc.readthedocs.io/en/latest/format.html
.. _classical style: https://www.sphinx-doc.org/en/master/domains.html#info-field-lists
